package de.tuberlin.tfs.ocl.metamodel.expressions;

import java.util.*;
import de.tuberlin.tfs.ocl.metamodel.types.*;
import de.tuberlin.tfs.ocl.metamodel.converter.*;
import ru.novosoft.uml.foundation.core.*;
// import ru.novosoft.uml.foundation.data_types.*;
// import ru.novosoft.uml.behavior.common_behavior.*;


public class MOperationCallExpImpl extends MModelPropertyCallExpImpl implements MOperationCallExp {

	protected ArrayList arguments;
	protected MOperation referredOperation;


	/** Getter for property arguments.
	 */
	public List getArguments() {
		if( this.arguments == null) {
			return new ArrayList();
		}
		ArrayList l = new ArrayList();
		Iterator i = this.arguments.iterator();
		while(i.hasNext()) {
			l.add(i.next());
		}
		return l;
	}

	/** Setter for property arguments.
	 */
	public void  setArguments(List arguments) {
		//maybe unset some link Information ????

		this.arguments = new ArrayList();
		Iterator i = arguments.iterator();
		while(i.hasNext()) {
			this.arguments.add(i.next());
		}
	}

	/** Adder for property arguments.
	 */
	public void addArguments(MOclExpression arguments) {
		if(this.arguments == null) {
			this.arguments = new ArrayList();
		}
		this.arguments.add(arguments);
		//arguments.internalSetEnum(this);
	}

	/** Remover for property arguments.
	 */
	public void removeArguments(MOclExpression arguments) {
		if(this.arguments == null) {
			this.arguments = new ArrayList();
		}
		this.arguments.remove(arguments);
		//arguments.internalSetEnum(null);
	}


	/** Getter for property referredOperation.
	 * @return Value of property referredOperation.
	 */
	public MOperation getReferredOperation() {
		return referredOperation;
	}

	/** Setter for property referredOperation.
	 * @param referredOperation value of property referredOperation.
	 */
	public void  setReferredOperation(MOperation referredOperation) {
		this.referredOperation = referredOperation;
	}



	public String convert2OclString () throws NoSuchAttributeException {

		StringBuffer strB = new StringBuffer();

		OclConverter.message("<MOperationCallExp>");

		// Array of all infix operators
		String[] operators = {
			"=", "<>", "+", "-", "*", "/", "<", ">", "<=", ">=",
			"not", "or", "xor", "and", "implies"
		};
		
		// there must be a referred operation (see above)
		OclConverter.checkAttribute(referredOperation, "referred operation", this);
		OclConverter.checkAttribute(referredOperation.getName(), "name of referred operation", this);

		String opName = referredOperation.getName();
		OclConverter.message("referredOperation: " + referredOperation.getName());

		boolean found = false;
		int j = 0;

		// test if an infix operator is used without a 2-arguments-operation
		// loop through infix operators
		while (j < operators.length && !found)
			if (opName.equals (operators[j]) ) found = true;
			else j++;

		if (found && arguments.size() != 2 && !opName.equals("not") && !opName.equals("-")) {
			OclConverter.checkAttribute(null, "infix operator with exactly 2 arguments", this);
		}


		// look for source
		if (source != null) {
			OclConverter.message("source found.");
			strB.append(getSource().convert2OclString() );

			// type available?
			OclConverter.checkAttribute(getSource().getType(), "type of source", this);

			// is source a collection or sth.? -> use "->"
			if (getSource().getType() instanceof MCollectionType
			  || getSource().getType() instanceof MSetType
			  || getSource().getType() instanceof MBagType
			  || getSource().getType() instanceof MSequenceType)
				strB.append("->");

			// Observer? -> use '^'
			else if (getSource().getType().getName().equals ("Observer") )
				strB.append("^");
			else strB.append(".");
		}
		else OclConverter.message("no source found.");


		// arguments at all?
		if (arguments == null || (arguments != null && arguments.size() == 0) ) {

			if (arguments == null) OclConverter.warning("missing arguments; proceeding...");

			OclConverter.message("0 arguments");

			strB.append(opName + "()");
			OclConverter.message("</MOperationCallExp>");
			return strB.toString();
		}



		// argument != null && argument.size() > 0 !
		Iterator i = arguments.iterator();

		// get first argument (often used)
		MOclExpression firstArg = (MOclExpressionImpl) i.next();
		MOclExpression nextArg;

		// firstArg must have a type!
		OclConverter.checkAttribute(firstArg.getType(), "type of first argument", this);

		String opLinker = "";


		switch (arguments.size()) {

			case 1:
				OclConverter.message("1 argument");

				// skip brackets with simple expressions!
				if ( (opName.equals ("not") || opName.equals ("-"))
				  && !(firstArg instanceof MOperationCallExp) ) {
					strB.append(opName + " " + firstArg.convert2OclString() );
					break;
				}
				
				strB.append(opName + "(" + firstArg.convert2OclString()	+ ")");
				break;
				

			case 2:
				OclConverter.message("2 arguments");

				// operator is a known infix operator?
				if (found) {
					if (firstArg instanceof MOperationCallExp)
						strB.append ("(" + firstArg.convert2OclString() + ") "	+ opName + " ");
						else strB.append (firstArg.convert2OclString() + " "	+ opName + " ");
					nextArg = (MOclExpressionImpl) i.next();

					OclConverter.checkAttribute(nextArg.getType(), "type of second argument", this);
					
					if (nextArg instanceof MOperationCallExp)
						strB.append ("(" +  nextArg.convert2OclString() +")" );
						else strB.append ( nextArg.convert2OclString() );

					break;
				}
				// no infix operator found -> goto else part of switch

			// (3 or more arguments) OR (2 arguments and no known infix operator)
			
			OclConverter.message(">2 arguments");

				// Collection types are linked by "->", Rest by "."
/*				if ( firstArgType instanceof MCollectionType
				  || firstArgType instanceof MSetType
				  || firstArgType instanceof MSequenceType
				  || firstArgType instanceof MBagType )
					opLinker = "->";
				else
					opLinker = ".";*/

				// linker, operator, bracket, 2nd expression
				strB.append (opLinker + opName + "("
					+ firstArg.convert2OclString() + ",");

				nextArg = (MOclExpressionImpl) i.next();

				OclConverter.checkAttribute(nextArg.getType(), "type of an argument", this);

				strB.append ( nextArg.convert2OclString() );


				// further expressions, if available
				while (i.hasNext() ) {
					nextArg = (MOclExpressionImpl) i.next();

					OclConverter.checkAttribute(nextArg.getType(), "type of an argument", this);

					strB.append ("," + nextArg.convert2OclString() );

				}

				// closing bracket
				strB.append (")");

				break;

		// end switch
		}

		OclConverter.message("</MOperationCallExp>");
		return strB.toString();
	}
}
