/*
 * OclMetaModel1.java
 *
 * Created on 10. Juli 2002, 16:25
 */

package de.tuberlin.tfs.ocl.metamodel.test;

import de.tuberlin.tfs.ocl.metamodel.expressions.*;
import de.tuberlin.tfs.ocl.metamodel.types.*;
import ru.novosoft.uml.foundation.core.*;

/**
 *
 * @author  jgusulde
 */
public class OclMetaModel5 implements OclMetaModelInstance {

    /** Creates a new instance of OclMetaModel1 */
    public MOclConstraint getOclConstraint() {
	//OclConverter.setDebugMode(true);

        // Types ---------------------------------------------------------------
        //BooleanType
        MClassifier booleanType = new MClassifierImpl();
        booleanType.setName("Boolean");
        // IntegerType
        MClassifier integerType = new MClassifierImpl();
        integerType.setName("Integer");
        // PersonType
        MClassifier personType = new MClassifierImpl();
        personType.setName("Person");
        
        //----------------------------------------------------------------------
        // VarialbeDeclaratin --------------------------------------------------
        // self
        MVariableExp selfExp = new MVariableExpImpl();
        MVariableDeclaration varD_self = new MVariableDeclarationImpl();
        varD_self.setVarname("self");
        varD_self.setType(personType);
        selfExp.setReferredVariable(varD_self);
        //----------------------------------------------------------------------
        MIntegerLiteralExp intExp18 = new MIntegerLiteralExpImpl();
        intExp18.setName("18");
        intExp18.setType(integerType);
        
        
        // --- OclConstraint
        MOclConstraint constraint = new MOclConstraintImpl();
        constraint.setKind(MOclConstraintKind.INV);
        constraint.setConstrainedElement(personType);
        
        // --- OperationCallExp
        MOperationCallExp operationCallExp = new MOperationCallExpImpl();
        constraint.setBody(operationCallExp);
        operationCallExp.setType(booleanType);
        // operation
        MOperation impliesOperation = new MOperationImpl();
        impliesOperation.setName("implies");
        operationCallExp.setReferredOperation(impliesOperation);
        

        // argument{1} -- OperationCallExp
        MOperationCallExp arg1 = new MOperationCallExpImpl();
        operationCallExp.addArguments(arg1);
        arg1.setType(booleanType);
        // operation
        MOperation equalsOperation = new MOperationImpl();
        equalsOperation.setName("=");
        arg1.setReferredOperation(equalsOperation);
        // argument{1_1}
        MAttributeCallExp arg1_1 = new MAttributeCallExpImpl();
        arg1.addArguments(arg1_1);
        MAttribute attribute1_1 = new MAttributeImpl();
        arg1_1.setReferredAttribute(attribute1_1);
        attribute1_1.setName("isMarried");
        attribute1_1.setType(booleanType);
        arg1_1.setSource(selfExp);
	arg1_1.setType(booleanType);

        // argument{1_2}
        MBooleanLiteralExpImpl arg1_2 = new MBooleanLiteralExpImpl();
        arg1.addArguments(arg1_2);
        arg1_2.setName("true");
        arg1_2.setType(booleanType);
        
        
        // argument{2} -- OperationCallExp
        MOperationCallExp arg2 = new MOperationCallExpImpl();
        operationCallExp.addArguments(arg2);
        arg2.setType(booleanType);
        // operation
        MOperation orOperation = new MOperationImpl();
        orOperation.setName("or");
        arg2.setReferredOperation(orOperation);
        
        // argument{2_1}
        MOperationCallExp arg2_1 = new MOperationCallExpImpl();
        arg2.addArguments(arg2_1);
        arg2_1.setType(booleanType);
        // operation
        MOperation greaterEqualOperation = new MOperationImpl();
        greaterEqualOperation.setName(">=");
        arg2_1.setReferredOperation(greaterEqualOperation);
        // argument{2_1_1}
        MAttributeCallExp arg2_1_1 = new MAttributeCallExpImpl();
        arg2_1.addArguments(arg2_1_1);
        arg2_1_1.setType(integerType);
        MAttribute ageAttribute = new MAttributeImpl();
        arg2_1_1.setReferredAttribute(ageAttribute);
        ageAttribute.setName("age");
        ageAttribute.setType(integerType);
        MAssociationEndCallExp source2_1_1 = new MAssociationEndCallExpImpl();
        arg2_1_1.setSource(source2_1_1);
        source2_1_1.setSource(selfExp);
        MAssociationEnd refAssSource2_1_1 = new MAssociationEndImpl();
        source2_1_1.setReferredAssociationEnd(refAssSource2_1_1);
        refAssSource2_1_1.setName("wife");
        refAssSource2_1_1.setType(personType);
        
        // argument{2_1_2}
        arg2_1.addArguments(intExp18);
        
        // argument{2_2}
        MOperationCallExp arg2_2 = new MOperationCallExpImpl();
        //operationCallExp.addArguments(arg2);
	arg2.addArguments(arg2_2);
        arg2_2.setType(booleanType);
        // operation
        arg2_2.setReferredOperation(greaterEqualOperation);
        // argument{2_2_1}
        MAttributeCallExp arg2_2_1 = new MAttributeCallExpImpl();
        arg2_2.addArguments(arg2_2_1);
        arg2_2_1.setType(integerType);
        arg2_2_1.setReferredAttribute(ageAttribute);
        MAssociationEndCallExp source2_2_1 = new MAssociationEndCallExpImpl();
        arg2_2_1.setSource(source2_2_1);
        source2_2_1.setSource(selfExp);
        MAssociationEnd refAssSource2_2_1 = new MAssociationEndImpl();
        source2_2_1.setReferredAssociationEnd(refAssSource2_2_1);
        refAssSource2_2_1.setName("husband");
        refAssSource2_2_1.setType(personType);
        
        // argument{2_2_2}
        arg2_2.addArguments(intExp18);
        
        return constraint;
    }
    
    public String getOclString() {
        return "context Person inv: self.isMarried = true implies ((self.wife.age >= 18) or (self.husband.age >= 18))";
    }    
}
