/**
 * (c) Copyright group Vilapower
 *
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0 
 * which accompanies this distribution, and is available at
 * http://www.tfs.cs.tu-berlin.de/vila
 * 
 * Contributors:
 *     	Eduard Weiss
 * 		Tony Modica
 * 		Frank Hermann
 * 		Holger Endert
 * 
 */
package vocleditor.commands.connect;

import org.eclipse.draw2d.*;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Point;

import vocleditor.figure.AssociationRoleFigure;

/**
 * Class       :AssociationEndRoleConstraint<br/>
 * Package     : vocleditor.commands.connect<br/>
 * Project     : VOCLEditor<br/>
 * Created On  : 22.05.2004<br/>
 * Description : Locator for AssociationEndRole
 * <br/>
 * @author vilapower
 */
public class AssociationEndRoleConstraint implements Locator{

	String text;
	boolean isEnd;
	Point offset;
	AssociationRoleFigure connFigure;

	public AssociationEndRoleConstraint(String text, boolean isEnd, Point offset, AssociationRoleFigure connFigure){
		this.text = text;
		this.isEnd = isEnd;
		this.offset = offset;
		this.connFigure = connFigure;
	}

	public void relocate(IFigure figure){
		Dimension minimum = FigureUtilities.getTextExtents(text, figure.getFont());
		figure.setSize(minimum);
		Point location;
		if (isEnd){
			location = connFigure.getEnd();
		}else{
			location = connFigure.getStart();
		}
		Point offsetCopy = offset.getCopy();
		offsetCopy.translate(location);
		figure.setLocation(offsetCopy);
	}
}
