/**
 * (c) Copyright group Vilapower
 *
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0 
 * which accompanies this distribution, and is available at
 * http://www.tfs.cs.tu-berlin.de/vila
 * 
 * Contributors:
 *     	Eduard Weiss
 * 		Tony Modica
 * 		Frank Hermann
 * 		Holger Endert
 * 
 */
package vocleditor.commands.create;

import vocleditor.model.VOCLModelManager;
import VOCLModel.ExpressionType;
import VOCLModel.IfExp;
import VOCLModel.NavExpContainer;
import VOCLModel.VOCLModel4Factory;
import VOCLModel.VOCLSash;

/**
 * @author eddi
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class CreateIfExpCommand extends CreateExpressionCommand {

	protected VOCLSash sashH;
	protected VOCLSash sashV;
	private int kind=0;


	
	/**
	 * Execution of this command creates a new IfExpresion
	 */
	public void execute() {
		VOCLModel4Factory mfc = VOCLModelManager.getFactory();
		sashH=mfc.createVOCLSash();
		sashH.setVertikal(false);
		sashV=mfc.createVOCLSash();
		sashV.setVertikal(true);
		((IfExp)expression).setHorizontal(sashH);
		((IfExp)expression).setProportionH(0.5);
		((IfExp)expression).setVertikal(sashV);
		((IfExp)expression).setProportionV(0.5);
		
		NavExpContainer container3=mfc.createNavExpContainer();	
		dublicate.dublicateContainer(container3,navexp);
		container3.setExptype(ExpressionType.IF_E_LITERAL);
		((IfExp)expression).setIfExpression(container3);
			
		NavExpContainer container1=mfc.createNavExpContainer();
		dublicate.dublicateContainer(container1,navexp);
		container1.setExptype(ExpressionType.THEN_E_LITERAL);		
		((IfExp)expression).setThenExpression(container1);
		
		NavExpContainer container2=mfc.createNavExpContainer();
		dublicate.dublicateContainer(container2,navexp);		
		container2.setExptype(ExpressionType.ELSE_E_LITERAL);		
		((IfExp)expression).setElseExpression(container2);
		
		super.execute();
	}
	
	/**
	 * Retrieves the kind of this expression
	 * @return - the kind as integer-value
	 */
	public int getKind() {
		return kind;
	}



}
