/**
 * (c) Copyright group Vilapower
 *
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0 
 * which accompanies this distribution, and is available at
 * http://www.tfs.cs.tu-berlin.de/vila
 * 
 * Contributors:
 *     	Eduard Weiss
 * 		Tony Modica
 * 		Frank Hermann
 * 		Holger Endert
 * 
 */
package vocleditor.dialogs;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.layout.RowData;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import org.eclipse.swt.widgets.Canvas;
import vocleditor.model.ConditionElement;

/**
* This code was generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a
* for-profit company or business) then you should purchase
* a license - please visit www.cloudgarden.com for details.
*/
public class AddConditionDialog extends org.eclipse.swt.widgets.Dialog {
	private Label label6;
	private Label label5;
	private Canvas canvas1;
	private Label label4;
	private Label valueRightLb;
	private Combo operation;
	private Label label3;
	private Label condition;
	private Composite composite3;
	private Label label2;
	private Label label1;
	private Combo typeRightTxt;
	private Text nameRightTxt;
	private Button isVariable;
	private Label typeRightLb;
	private Label nameRightLb;
	private Composite composite2;
	private Label nameLeftLb;
	private Combo typeLeftTxt;
	private Label typeLeftLb;
	private Text nameLeftTxt;
	private Composite composite1;
	private Button ApllyBtn;
	private Button CancelBtn;
	private Composite buttons;
	private Shell dialogShell;
	private Group attDescr;
	
	private boolean state=false;
	private boolean isRightSideVar=false;
	private ConditionElement conElem=new ConditionElement();
	
	public AddConditionDialog(Shell parent, int style) {
		super(parent, style);
	}

	/** Auto-generated event handler method */
	protected void CancelBtnMouseDown(MouseEvent evt){
		dialogShell.close();
	}

	/** Auto-generated event handler method */
	protected void ApllyBtnMouseDown(MouseEvent evt){
		if(isRightSideVar()){
			String t1=typeLeftTxt.getText();
			String t2=typeRightTxt.getText();
			if(! t1.trim().equals(t2.trim())){
				// Show Error Dialog
				MessageBox msgb = new MessageBox(dialogShell,0);
				msgb.setText("Shit happens!");
				msgb.setMessage("The types of left side and right side must be idetnical!");
				msgb.open();
				return;	
			}else if(nameRightTxt.getText().trim().length()==0){
				// Show Error Dialog
				MessageBox msgb = new MessageBox(dialogShell,0);
				msgb.setText("Shit happens!");
				msgb.setMessage("Name is empty!");
				msgb.open();
				return;	
			}
		}else{
			if(nameRightTxt.getText().trim().length()==0){
				// Show Error Dialog
				MessageBox msgb = new MessageBox(dialogShell,0);
				msgb.setText("Shit happens!");
				msgb.setMessage("Value is empty!");
				msgb.open();
				return;				
			}else if(nameLeftTxt.getText().trim().length()==0){
				// Show Error Dialog
				MessageBox msgb = new MessageBox(dialogShell,0);
				msgb.setText("Shit happens!");
				msgb.setMessage("Name is empty!");
				msgb.open();
				return;	
			}
		}
		
		conElem.setRightVar(isRightSideVar());
		conElem.setOp(operation.getItem(operation.getSelectionIndex()));
		conElem.setLeftVarType(typeLeftTxt.getText());
		conElem.setLeftVarName(nameLeftTxt.getText().trim());
		if(isRightSideVar()){
			conElem.setRightVarType(typeRightTxt.getText());
			conElem.setRightVarName(nameRightTxt.getText().trim());		
			conElem.setValue("");	
		}else conElem.setValue(nameRightTxt.getText());
		setState(true);
		dialogShell.close();
	}

	/**
	* Opens the Dialog Shell.
	* Auto-generated code - any changes you make will disappear.
	*/
	public void open(){
		try {
			preInitGUI();
	
			Shell parent = getParent();
			dialogShell = new Shell(parent, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);
			dialogShell.setText(getText());
			composite3 = new Composite(dialogShell,SWT.NULL);
			label6 = new Label(composite3,SWT.NULL);
			label5 = new Label(composite3,SWT.NULL);
			operation = new Combo(composite3,SWT.READ_ONLY| SWT.BORDER);
			label3 = new Label(composite3,SWT.NULL);
			label4 = new Label(composite3,SWT.NULL);
			attDescr = new Group(dialogShell,SWT.NULL);
			composite1 = new Composite(attDescr,SWT.NULL);
			label1 = new Label(composite1,SWT.NULL);
			typeLeftLb = new Label(composite1,SWT.NULL);
			nameLeftLb = new Label(composite1,SWT.NULL);
			nameLeftTxt = new Text(composite1,SWT.BORDER);
			typeLeftTxt = new Combo(composite1,SWT.NULL);
			canvas1 = new Canvas(attDescr,SWT.NULL);
			composite2 = new Composite(attDescr,SWT.NULL);
			valueRightLb = new Label(composite2,SWT.NULL);
			label2 = new Label(composite2,SWT.NULL);
			typeRightTxt = new Combo(composite2,SWT.BORDER);
			nameRightTxt = new Text(composite2,SWT.BORDER);
			isVariable = new Button(composite2,SWT.CHECK| SWT.LEFT);
			typeRightLb = new Label(composite2,SWT.NULL);
			nameRightLb = new Label(composite2,SWT.NULL);
			buttons = new Composite(dialogShell,SWT.NULL);
			CancelBtn = new Button(buttons,SWT.PUSH| SWT.CENTER);
			ApllyBtn = new Button(buttons,SWT.PUSH| SWT.CENTER);
	
			dialogShell.setSize(new org.eclipse.swt.graphics.Point(490,261));
	
			RowData composite3LData = new RowData(484, 65);
			composite3.setLayoutData(composite3LData);
			composite3.setSize(new org.eclipse.swt.graphics.Point(484,65));
			final Color composite3background = new Color(Display.getDefault(),255,255,255);
			composite3.setBackground(composite3background);
	
			FormData label6LData = new FormData();
			label6LData.height = 57;
			label6LData.width = 64;
			label6LData.left =  new FormAttachment(13, 1000, 0);
			label6LData.right =  new FormAttachment(145, 1000, 0);
			label6LData.top =  new FormAttachment(53, 1000, 0);
			label6LData.bottom =  new FormAttachment(930, 1000, 0);
			label6.setLayoutData(label6LData);
			label6.setText("label6");
			final org.eclipse.swt.graphics.Image label6image = new org.eclipse.swt.graphics.Image(Display.getDefault(), getClass().getClassLoader().getResourceAsStream("vocleditor/dialogs/fig/newEEnum_wizR.GIF"));
			label6image.setBackground(label6.getBackground());
			label6.setImage(label6image);
			label6.setSize(new org.eclipse.swt.graphics.Point(64,57));
	
			FormData label5LData = new FormData();
			label5LData.height = 57;
			label5LData.width = 66;
			label5LData.left =  new FormAttachment(852, 1000, 0);
			label5LData.right =  new FormAttachment(988, 1000, 0);
			label5LData.top =  new FormAttachment(69, 1000, 0);
			label5LData.bottom =  new FormAttachment(946, 1000, 0);
			label5.setLayoutData(label5LData);
			label5.setText("label5");
			final org.eclipse.swt.graphics.Image label5image = new org.eclipse.swt.graphics.Image(Display.getDefault(), getClass().getClassLoader().getResourceAsStream("vocleditor/dialogs/fig/NewCondition.gif"));
			label5image.setBackground(label5.getBackground());
			label5.setImage(label5image);
			label5.setSize(new org.eclipse.swt.graphics.Point(66,57));
	
			FormData operationLData = new FormData();
			operationLData.height = 31;
			operationLData.width = 21;
			operationLData.left =  new FormAttachment(465, 1000, 0);
			operationLData.right =  new FormAttachment(560, 1000, 0);
			operationLData.top =  new FormAttachment(576, 1000, 0);
			operationLData.bottom =  new FormAttachment(976, 1000, 0);
			operation.setLayoutData(operationLData);
			operation.setSize(new org.eclipse.swt.graphics.Point(21,31));
			final Font operationfont = new Font(Display.getDefault(),"Courier New",12,1);
			operation.setFont(operationfont);
	
			FormData label3LData = new FormData();
			label3LData.height = 20;
			label3LData.width = 155;
			label3LData.left =  new FormAttachment(213, 1000, 0);
			label3LData.right =  new FormAttachment(534, 1000, 0);
			label3LData.top =  new FormAttachment(115, 1000, 0);
			label3LData.bottom =  new FormAttachment(423, 1000, 0);
			label3.setLayoutData(label3LData);
			label3.setText("Condition");
			label3.setSize(new org.eclipse.swt.graphics.Point(155,20));
			label3.setBackground(composite3background);
			final Font label3font = new Font(Display.getDefault(),"Courier New",16,3);
			label3.setFont(label3font);
	
			FormData label4LData = new FormData();
			label4LData.height = 20;
			label4LData.width = 100;
			label4LData.left =  new FormAttachment(253, 1000, 0);
			label4LData.right =  new FormAttachment(459, 1000, 0);
			label4LData.top =  new FormAttachment(638, 1000, 0);
			label4LData.bottom =  new FormAttachment(946, 1000, 0);
			label4.setLayoutData(label4LData);
			label4.setText("Operation:");
			label4.setSize(new org.eclipse.swt.graphics.Point(100,20));
			label4.setBackground(composite3background);
			label4.setFont(operationfont);
			FormLayout composite3Layout = new FormLayout();
			composite3.setLayout(composite3Layout);
			composite3Layout.marginWidth = 0;
			composite3Layout.marginHeight = 0;
			composite3.layout();
	
			RowData attDescrLData = new RowData(477, 138);
			attDescr.setLayoutData(attDescrLData);
			attDescr.setText("Condition");
			attDescr.setSize(new org.eclipse.swt.graphics.Point(477,138));
			final Color attDescrbackground = new Color(Display.getDefault(),224,223,227);
			attDescr.setBackground(attDescrbackground);
			final Font attDescrfont = new Font(Display.getDefault(),"Courier New",8,0);
			attDescr.setFont(attDescrfont);
	
			RowData composite1LData = new RowData(230, 110);
			composite1.setLayoutData(composite1LData);
			composite1.setSize(new org.eclipse.swt.graphics.Point(230,110));
	
			FormData label1LData = new FormData();
			label1LData.height = 20;
			label1LData.width = 100;
			label1LData.left =  new FormAttachment(23, 1000, 0);
			label1LData.right =  new FormAttachment(458, 1000, 0);
			label1LData.top =  new FormAttachment(50, 1000, 0);
			label1LData.bottom =  new FormAttachment(231, 1000, 0);
			label1.setLayoutData(label1LData);
			label1.setText("Left side");
			label1.setSize(new org.eclipse.swt.graphics.Point(100,20));
			label1.setEnabled(true);
			final Font label1font = new Font(Display.getDefault(),"Courier New",12,3);
			label1.setFont(label1font);
	
			FormData typeLeftLbLData = new FormData();
			typeLeftLbLData.height = 20;
			typeLeftLbLData.width = 55;
			typeLeftLbLData.left =  new FormAttachment(23, 1000, 0);
			typeLeftLbLData.right =  new FormAttachment(263, 1000, 0);
			typeLeftLbLData.top =  new FormAttachment(686, 1000, 0);
			typeLeftLbLData.bottom =  new FormAttachment(868, 1000, 0);
			typeLeftLb.setLayoutData(typeLeftLbLData);
			typeLeftLb.setText("Type:");
			typeLeftLb.setSize(new org.eclipse.swt.graphics.Point(55,20));
			typeLeftLb.setFont(operationfont);
	
			FormData nameLeftLbLData = new FormData();
			nameLeftLbLData.height = 20;
			nameLeftLbLData.width = 55;
			nameLeftLbLData.left =  new FormAttachment(23, 1000, 0);
			nameLeftLbLData.right =  new FormAttachment(263, 1000, 0);
			nameLeftLbLData.top =  new FormAttachment(459, 1000, 0);
			nameLeftLbLData.bottom =  new FormAttachment(640, 1000, 0);
			nameLeftLb.setLayoutData(nameLeftLbLData);
			nameLeftLb.setText("Name:");
			nameLeftLb.setSize(new org.eclipse.swt.graphics.Point(55,20));
			nameLeftLb.setFont(operationfont);
	
			FormData nameLeftTxtLData = new FormData();
			nameLeftTxtLData.height = 13;
			nameLeftTxtLData.width = 113;
			nameLeftTxtLData.left =  new FormAttachment(271, 1000, 0);
			nameLeftTxtLData.right =  new FormAttachment(793, 1000, 0);
			nameLeftTxtLData.top =  new FormAttachment(459, 1000, 0);
			nameLeftTxtLData.bottom =  new FormAttachment(640, 1000, 0);
			nameLeftTxt.setLayoutData(nameLeftTxtLData);
			final Font nameLeftTxtfont = new Font(Display.getDefault(),"Courier New",10,0);
			nameLeftTxt.setFont(nameLeftTxtfont);
			nameLeftTxt.setSize(new org.eclipse.swt.graphics.Point(113,13));
	
			FormData typeLeftTxtLData = new FormData();
			typeLeftTxtLData.height = 27;
			typeLeftTxtLData.width = 115;
			typeLeftTxtLData.left =  new FormAttachment(271, 1000, 0);
			typeLeftTxtLData.right =  new FormAttachment(880, 1000, 0);
			typeLeftTxtLData.top =  new FormAttachment(659, 1000, 0);
			typeLeftTxtLData.bottom =  new FormAttachment(850, 1000, 0);
			typeLeftTxt.setLayoutData(typeLeftTxtLData);
			typeLeftTxt.setSize(new org.eclipse.swt.graphics.Point(115,27));
			typeLeftTxt.setFont(nameLeftTxtfont);
			FormLayout composite1Layout = new FormLayout();
			composite1.setLayout(composite1Layout);
			composite1Layout.marginWidth = 0;
			composite1Layout.marginHeight = 0;
			composite1.layout();
	
			RowData canvas1LData = new RowData(4, 116);
			canvas1.setLayoutData(canvas1LData);
			canvas1.setSize(new org.eclipse.swt.graphics.Point(4,116));
			final Color canvas1background = new Color(Display.getDefault(),64,0,64);
			canvas1.setBackground(canvas1background);
	
			RowData composite2LData = new RowData(230, 110);
			composite2.setLayoutData(composite2LData);
			composite2.setSize(new org.eclipse.swt.graphics.Point(230,110));
	
			FormData valueRightLbLData = new FormData();
			valueRightLbLData.height = 20;
			valueRightLbLData.width = 55;
			valueRightLbLData.left =  new FormAttachment(23, 1000, 0);
			valueRightLbLData.right =  new FormAttachment(263, 1000, 0);
			valueRightLbLData.top =  new FormAttachment(459, 1000, 0);
			valueRightLbLData.bottom =  new FormAttachment(640, 1000, 0);
			valueRightLb.setLayoutData(valueRightLbLData);
			valueRightLb.setText("Value:");
			valueRightLb.setSize(new org.eclipse.swt.graphics.Point(55,20));
			valueRightLb.setFont(operationfont);
	
			FormData label2LData = new FormData();
			label2LData.height = 20;
			label2LData.width = 110;
			label2LData.left =  new FormAttachment(23, 1000, 0);
			label2LData.right =  new FormAttachment(502, 1000, 0);
			label2LData.top =  new FormAttachment(50, 1000, 0);
			label2LData.bottom =  new FormAttachment(231, 1000, 0);
			label2.setLayoutData(label2LData);
			label2.setText("Right side");
			label2.setSize(new org.eclipse.swt.graphics.Point(110,20));
			label2.setFont(label1font);
	
			FormData typeRightTxtLData = new FormData();
			typeRightTxtLData.height = 27;
			typeRightTxtLData.width = 115;
			typeRightTxtLData.left =  new FormAttachment(271, 1000, 0);
			typeRightTxtLData.right =  new FormAttachment(880, 1000, 0);
			typeRightTxtLData.top =  new FormAttachment(659, 1000, 0);
			typeRightTxtLData.bottom =  new FormAttachment(850, 1000, 0);
			typeRightTxt.setLayoutData(typeRightTxtLData);
			typeRightTxt.setSize(new org.eclipse.swt.graphics.Point(115,27));
			typeRightTxt.setFont(nameLeftTxtfont);
	
			FormData nameRightTxtLData = new FormData();
			nameRightTxtLData.height = 13;
			nameRightTxtLData.width = 113;
			nameRightTxtLData.left =  new FormAttachment(267, 1000, 0);
			nameRightTxtLData.right =  new FormAttachment(789, 1000, 0);
			nameRightTxtLData.top =  new FormAttachment(459, 1000, 0);
			nameRightTxtLData.bottom =  new FormAttachment(640, 1000, 0);
			nameRightTxt.setLayoutData(nameRightTxtLData);
			nameRightTxt.setFont(nameLeftTxtfont);
			nameRightTxt.setSize(new org.eclipse.swt.graphics.Point(113,13));
	
			FormData isVariableLData = new FormData();
			isVariableLData.height = 20;
			isVariableLData.width = 100;
			isVariableLData.left =  new FormAttachment(545, 1000, 0);
			isVariableLData.right =  new FormAttachment(980, 1000, 0);
			isVariableLData.top =  new FormAttachment(50, 1000, 0);
			isVariableLData.bottom =  new FormAttachment(231, 1000, 0);
			isVariable.setLayoutData(isVariableLData);
			isVariable.setSelection(true);
			isVariable.setText("is value?");
			isVariable.setSize(new org.eclipse.swt.graphics.Point(100,20));
			final Font isVariablefont = new Font(Display.getDefault(),"Courier New",10,1);
			isVariable.setFont(isVariablefont);
			isVariable.addSelectionListener( new SelectionAdapter() {
				public void widgetSelected(SelectionEvent evt) {
					isVariableWidgetSelected(evt);
				}
			});
	
			FormData typeRightLbLData = new FormData();
			typeRightLbLData.height = 20;
			typeRightLbLData.width = 55;
			typeRightLbLData.left =  new FormAttachment(23, 1000, 0);
			typeRightLbLData.right =  new FormAttachment(263, 1000, 0);
			typeRightLbLData.top =  new FormAttachment(686, 1000, 0);
			typeRightLbLData.bottom =  new FormAttachment(868, 1000, 0);
			typeRightLb.setLayoutData(typeRightLbLData);
			typeRightLb.setText("Type:");
			typeRightLb.setSize(new org.eclipse.swt.graphics.Point(55,20));
			typeRightLb.setFont(operationfont);
	
			FormData nameRightLbLData = new FormData();
			nameRightLbLData.height = 20;
			nameRightLbLData.width = 55;
			nameRightLbLData.left =  new FormAttachment(23, 1000, 0);
			nameRightLbLData.right =  new FormAttachment(263, 1000, 0);
			nameRightLbLData.top =  new FormAttachment(459, 1000, 0);
			nameRightLbLData.bottom =  new FormAttachment(640, 1000, 0);
			nameRightLb.setLayoutData(nameRightLbLData);
			nameRightLb.setText("Name:");
			nameRightLb.setSize(new org.eclipse.swt.graphics.Point(55,20));
			nameRightLb.setFont(operationfont);
			FormLayout composite2Layout = new FormLayout();
			composite2.setLayout(composite2Layout);
			composite2Layout.marginWidth = 0;
			composite2Layout.marginHeight = 0;
			composite2.layout();
			RowLayout attDescrLayout = new RowLayout(256);
			attDescr.setLayout(attDescrLayout);
			attDescrLayout.type = SWT.HORIZONTAL;
			attDescrLayout.wrap = true;
			attDescrLayout.pack = true;
			attDescrLayout.justify = false;
			attDescrLayout.spacing = 3;
			attDescrLayout.marginLeft = 3;
			attDescrLayout.marginTop = 3;
			attDescrLayout.marginRight = 3;
			attDescrLayout.marginBottom = 3;
			attDescr.layout();
	
			RowData buttonsLData = new RowData(484, 46);
			buttons.setLayoutData(buttonsLData);
			buttons.setSize(new org.eclipse.swt.graphics.Point(484,46));
	
			FormData CancelBtnLData = new FormData();
			CancelBtnLData.height = 20;
			CancelBtnLData.width = 120;
			CancelBtnLData.left =  new FormAttachment(682, 1000, 0);
			CancelBtnLData.right =  new FormAttachment(930, 1000, 0);
			CancelBtnLData.top =  new FormAttachment(119, 1000, 0);
			CancelBtnLData.bottom =  new FormAttachment(554, 1000, 0);
			CancelBtn.setLayoutData(CancelBtnLData);
			CancelBtn.setText("CANCEL");
			CancelBtn.setSize(new org.eclipse.swt.graphics.Point(120,20));
			final Font CancelBtnfont = new Font(Display.getDefault(),"Courier New",8,1);
			CancelBtn.setFont(CancelBtnfont);
			CancelBtn.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					CancelBtnMouseDown(evt);
				}
			});
	
			FormData ApllyBtnLData = new FormData();
			ApllyBtnLData.height = 20;
			ApllyBtnLData.width = 120;
			ApllyBtnLData.left =  new FormAttachment(38, 1000, 0);
			ApllyBtnLData.right =  new FormAttachment(286, 1000, 0);
			ApllyBtnLData.top =  new FormAttachment(119, 1000, 0);
			ApllyBtnLData.bottom =  new FormAttachment(554, 1000, 0);
			ApllyBtn.setLayoutData(ApllyBtnLData);
			ApllyBtn.setText("APPLY");
			ApllyBtn.setSize(new org.eclipse.swt.graphics.Point(120,20));
			ApllyBtn.setFont(CancelBtnfont);
			ApllyBtn.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					ApllyBtnMouseDown(evt);
				}
			});
			FormLayout buttonsLayout = new FormLayout();
			buttons.setLayout(buttonsLayout);
			buttonsLayout.marginWidth = 0;
			buttonsLayout.marginHeight = 0;
			buttons.layout();
			RowLayout dialogShellLayout = new RowLayout(256);
			dialogShell.setLayout(dialogShellLayout);
			dialogShellLayout.type = SWT.HORIZONTAL;
			dialogShellLayout.wrap = true;
			dialogShellLayout.pack = true;
			dialogShellLayout.justify = false;
			dialogShellLayout.spacing = 3;
			dialogShellLayout.marginLeft = 3;
			dialogShellLayout.marginTop = 3;
			dialogShellLayout.marginRight = 3;
			dialogShellLayout.marginBottom = 3;
			dialogShell.layout();
			dialogShell.addDisposeListener(new DisposeListener() {
				public void widgetDisposed(DisposeEvent e) {
					composite3background.dispose();
					label6image.dispose();
					label5image.dispose();
					operationfont.dispose();
					label3font.dispose();
					attDescrbackground.dispose();
					attDescrfont.dispose();
					label1font.dispose();
					nameLeftTxtfont.dispose();
					canvas1background.dispose();
					isVariablefont.dispose();
					CancelBtnfont.dispose();
				}
			});
			Rectangle bounds = dialogShell.computeTrim(0, 0, 490,261);
			dialogShell.setSize(bounds.width, bounds.height);
			postInitGUI();
			dialogShell.open();
			Display display = dialogShell.getDisplay();
			while (!dialogShell.isDisposed()) {
				if (!display.readAndDispatch())
					display.sleep();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	/** Add your pre-init code in here 	*/
	public void preInitGUI(){
	}

	/** Add your post-init code in here 	*/
	public void postInitGUI(){
		typeRightTxt.add("String");typeRightTxt.add("Integer");
		typeRightTxt.add("Boolean");typeRightTxt.add("Double");
		typeRightTxt.add("Short");typeRightTxt.add("Byte");
		typeLeftTxt.add("String");typeLeftTxt.add("Integer");
		typeLeftTxt.add("Boolean");typeLeftTxt.add("Double");
		typeLeftTxt.add("Short");typeLeftTxt.add("Byte");
		
		operation.add("=");operation.add(">");operation.add("<");
		operation.add(">=");operation.add("<=");operation.add("<>");
		operation.select(0);
		setValuesOfDialog();
	}
	


	private void setValuesOfDialog(){
		if(conElem==null){
			initRightVar(false);
			return;
		}

		typeLeftTxt.setText(conElem.getLeftVarType());
		nameLeftTxt.setText(conElem.getLeftVarName());
		operation.setText(conElem.getOp());
		setRightSideVar(conElem.isRightVar());
		if(conElem.isRightVar()){
			typeRightTxt.setText(conElem.getRightVarType());
			nameRightTxt.setText(conElem.getRightVarName());
			initRightVar(true);	
			isVariable.setSelection(false);	
		}else{
			nameRightTxt.setText(conElem.getValue());
			initRightVar(false);
			isVariable.setSelection(true);	
		}				
	}


	private void initRightVar(boolean b){
		this.typeRightLb.setVisible(b);
		this.typeRightTxt.setVisible(b);
		this.nameRightLb.setVisible(b);
		this.valueRightLb.setVisible(!b);
	}
	/** Auto-generated main method */
	public static void main(String[] args){
		showGUI();
	}

	/**
	* This static method creates a new instance of this class and shows
	* it inside a new Shell.
	*
	* It is a convenience method for showing the GUI, but it can be
	* copied and used as a basis for your own code.	*
	* It is auto-generated code - the body of this method will be
	* re-generated after any changes are made to the GUI.
	* However, if you delete this method it will not be re-created.	*/
	public static void showGUI(){
		try {
			Display display = Display.getDefault();
			Shell shell = new Shell(display);
			AddConditionDialog inst = new AddConditionDialog(shell, SWT.NULL);
			inst.open();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	/** Auto-generated event handler method */
	protected void isVariableWidgetSelected(SelectionEvent evt){
		if(isVariable.getSelection()){
			setRightSideVar(false);
			initRightVar(false);
		}
		else{
			setRightSideVar(true);
			initRightVar(true);
		 }
	}
	/**
	 * @return
	 */
	public boolean isState() {
		return state;
	}

	/**
	 * @param b
	 */
	public void setState(boolean b) {
		state = b;
	}

	
	/**
	 * @return
	 */
	public boolean isRightSideVar() {
		return isRightSideVar;
	}

	/**
	 * @param b
	 */
	public void setRightSideVar(boolean b) {
		isRightSideVar = b;
	}


	/**
	 * @return
	 */
	public ConditionElement getConElem() {
		return conElem;
	}

	/**
	 * @param element
	 */
	public void setConElem(ConditionElement element) {
		conElem = element;
	}

}
