/**
 * (c) Copyright group Vilapower
 *
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0 
 * which accompanies this distribution, and is available at
 * http://www.tfs.cs.tu-berlin.de/vila
 * 
 * Contributors:
 *     	Eduard Weiss
 * 		Tony Modica
 * 		Frank Hermann
 * 		Holger Endert
 * 
 */
package vocleditor.dialogs;

import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.events.VerifyListener;
import org.eclipse.swt.events.VerifyEvent;
import org.eclipse.swt.SWT;

/**
* This code was generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a
* for-profit company or business) then you should purchase
* a license - please visit www.cloudgarden.com for details.
*/
public class CreateNewClassDialog extends org.eclipse.swt.widgets.Dialog {
	private Label label2;
	private Label label1;
	private Label msgLb2;
	private Label msgLb1;
	private Label msgLbI;
	private Text classnameT;
	private Label classnameLb;
	private Label cle;
	private Label cl;
	private Composite composite3;
	private Button OK;
	private Button cancel;
	private Composite composite2;
	private Text varnameT;
	private Label varnameLb;
	private Group composite1;
	private Shell dialogShell;
	private boolean status;
	private String className;
	private String varName;
	static private String msg1="Type classname is empty ";
	static private String msg2a="Type classname is discouraged.By convention,";
	static private String msg2b="classname usually start with an uppercase latter.";
								
	public CreateNewClassDialog(Shell parent, int style) {
		super(parent, style);
	}
	public CreateNewClassDialog(Shell parent) {
		super(parent);
	}
	/**
	* Opens the Dialog Shell.
	* Auto-generated code - any changes you make will disappear.
	*/
	public void open(){
		try {
			preInitGUI();
	
			Shell parent = getParent();
			dialogShell = new Shell(parent, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);
			dialogShell.setText(getText());
			composite3 = new Composite(dialogShell,SWT.NULL);
			cl = new Label(composite3,SWT.NULL);
			cle = new Label(composite3,SWT.NULL);
			msgLbI = new Label(composite3,SWT.NULL);
			msgLb1 = new Label(composite3,SWT.NULL);
			msgLb2 = new Label(composite3,SWT.NULL);
			label1 = new Label(composite3,SWT.NULL);
			label2 = new Label(composite3,SWT.NULL);
			composite1 = new Group(dialogShell,SWT.NULL);
			varnameLb = new Label(composite1,SWT.NULL);
			varnameT = new Text(composite1,SWT.BORDER);
			classnameLb = new Label(composite1,SWT.NULL);
			classnameT = new Text(composite1,SWT.BORDER);
			composite2 = new Composite(dialogShell,SWT.NULL);
			OK = new Button(composite2,SWT.PUSH| SWT.CENTER);
			cancel = new Button(composite2,SWT.PUSH| SWT.CENTER);
	
			dialogShell.setText("New Class");
			dialogShell.setSize(new org.eclipse.swt.graphics.Point(471,245));
	
			GridData composite3LData = new GridData();
			composite3LData.verticalAlignment = GridData.CENTER;
			composite3LData.horizontalAlignment = GridData.BEGINNING;
			composite3LData.widthHint = 464;
			composite3LData.heightHint = 70;
			composite3LData.horizontalIndent = 0;
			composite3LData.horizontalSpan = 1;
			composite3LData.verticalSpan = 1;
			composite3LData.grabExcessHorizontalSpace = false;
			composite3LData.grabExcessVerticalSpace = false;
			composite3.setLayoutData(composite3LData);
			composite3.setSize(new org.eclipse.swt.graphics.Point(464,70));
			final Color composite3background = new Color(Display.getDefault(),255,255,255);
			composite3.setBackground(composite3background);
	
			cl.setText("Classifier");
			cl.setSize(new org.eclipse.swt.graphics.Point(102,17));
			cl.setBackground(composite3background);
			cl.setBounds(new org.eclipse.swt.graphics.Rectangle(78,4,102,17));
			final Font clfont = new Font(Display.getDefault(),"Courier New",12,1);
			cl.setFont(clfont);
	
			cle.setText("Create New Classifier");
			cle.setSize(new org.eclipse.swt.graphics.Point(173,20));
			cle.setBackground(composite3background);
			cle.setBounds(new org.eclipse.swt.graphics.Rectangle(198,4,173,20));
			final Font clefont = new Font(Display.getDefault(),"Courier New",10,0);
			cle.setFont(clefont);
	
			final org.eclipse.swt.graphics.Image msgLbIimage = new org.eclipse.swt.graphics.Image(Display.getDefault(), getClass().getClassLoader().getResourceAsStream("vocleditor/dialogs/fig/error_st_obj.gif"));
			msgLbIimage.setBackground(msgLbI.getBackground());
			msgLbI.setImage(msgLbIimage);
			msgLbI.setSize(new org.eclipse.swt.graphics.Point(20,16));
			msgLbI.setBackground(composite3background);
			msgLbI.setBounds(new org.eclipse.swt.graphics.Rectangle(84,26,20,16));
	
			msgLb1.setSize(new org.eclipse.swt.graphics.Point(276,14));
			msgLb1.setBackground(composite3background);
			msgLb1.setBounds(new org.eclipse.swt.graphics.Rectangle(105,26,276,14));
			msgLb1.setFont(clefont);
	
			msgLb2.setSize(new org.eclipse.swt.graphics.Point(287,15));
			msgLb2.setBackground(composite3background);
			msgLb2.setBounds(new org.eclipse.swt.graphics.Rectangle(89,47,287,15));
			msgLb2.setFont(clefont);
	
			label1.setText("label1");
			final org.eclipse.swt.graphics.Image label1image = new org.eclipse.swt.graphics.Image(Display.getDefault(), getClass().getClassLoader().getResourceAsStream("vocleditor/dialogs/fig/newclass_wiz.gif"));
			label1image.setBackground(label1.getBackground());
			label1.setImage(label1image);
			label1.setSize(new org.eclipse.swt.graphics.Point(76,49));
			label1.setBounds(new org.eclipse.swt.graphics.Rectangle(384,6,76,49));
	
			label2.setText("label2");
			final org.eclipse.swt.graphics.Image label2image = new org.eclipse.swt.graphics.Image(Display.getDefault(), getClass().getClassLoader().getResourceAsStream("vocleditor/dialogs/fig/newEEnum_wizR.GIF"));
			label2image.setBackground(label2.getBackground());
			label2.setImage(label2image);
			label2.setSize(new org.eclipse.swt.graphics.Point(60,50));
			label2.setBounds(new org.eclipse.swt.graphics.Rectangle(7,4,60,50));
			composite3.setLayout(null);
	
			GridData composite1LData = new GridData();
			composite1LData.verticalAlignment = GridData.CENTER;
			composite1LData.horizontalAlignment = GridData.BEGINNING;
			composite1LData.widthHint = 458;
			composite1LData.heightHint = 98;
			composite1LData.horizontalIndent = 0;
			composite1LData.horizontalSpan = 1;
			composite1LData.verticalSpan = 1;
			composite1LData.grabExcessHorizontalSpace = false;
			composite1LData.grabExcessVerticalSpace = false;
			composite1.setLayoutData(composite1LData);
			composite1.setSize(new org.eclipse.swt.graphics.Point(458,98));
			final Font composite1font = new Font(Display.getDefault(),"Tahoma",8,0);
			composite1.setFont(composite1font);
	
			GridData varnameLbLData = new GridData();
			varnameLbLData.verticalAlignment = GridData.CENTER;
			varnameLbLData.horizontalAlignment = GridData.BEGINNING;
			varnameLbLData.widthHint = 125;
			varnameLbLData.heightHint = 20;
			varnameLbLData.horizontalIndent = 0;
			varnameLbLData.horizontalSpan = 1;
			varnameLbLData.verticalSpan = 1;
			varnameLbLData.grabExcessHorizontalSpace = false;
			varnameLbLData.grabExcessVerticalSpace = false;
			varnameLb.setLayoutData(varnameLbLData);
			varnameLb.setText("Variablename:");
			varnameLb.setSize(new org.eclipse.swt.graphics.Point(125,20));
			varnameLb.setFont(clfont);
	
			GridData varnameTLData = new GridData();
			varnameTLData.verticalAlignment = GridData.CENTER;
			varnameTLData.horizontalAlignment = GridData.BEGINNING;
			varnameTLData.widthHint = 313;
			varnameTLData.heightHint = 16;
			varnameTLData.horizontalIndent = 0;
			varnameTLData.horizontalSpan = 1;
			varnameTLData.verticalSpan = 1;
			varnameTLData.grabExcessHorizontalSpace = false;
			varnameTLData.grabExcessVerticalSpace = false;
			varnameT.setLayoutData(varnameTLData);
			varnameT.setFont(clefont);
			varnameT.setSize(new org.eclipse.swt.graphics.Point(313,16));
			varnameT.setBackground(composite3background);
			varnameT.setEnabled(true);
	
			GridData classnameLbLData = new GridData();
			classnameLbLData.verticalAlignment = GridData.CENTER;
			classnameLbLData.horizontalAlignment = GridData.BEGINNING;
			classnameLbLData.widthHint = 125;
			classnameLbLData.heightHint = 20;
			classnameLbLData.horizontalIndent = 0;
			classnameLbLData.horizontalSpan = 1;
			classnameLbLData.verticalSpan = 1;
			classnameLbLData.grabExcessHorizontalSpace = false;
			classnameLbLData.grabExcessVerticalSpace = false;
			classnameLb.setLayoutData(classnameLbLData);
			classnameLb.setAlignment(SWT.RIGHT);
			classnameLb.setText(" Classname:");
			classnameLb.setSize(new org.eclipse.swt.graphics.Point(125,20));
			classnameLb.setFont(clfont);
	
			GridData classnameTLData = new GridData();
			classnameTLData.verticalAlignment = GridData.CENTER;
			classnameTLData.horizontalAlignment = GridData.BEGINNING;
			classnameTLData.widthHint = 313;
			classnameTLData.heightHint = 16;
			classnameTLData.horizontalIndent = 0;
			classnameTLData.horizontalSpan = 1;
			classnameTLData.verticalSpan = 1;
			classnameTLData.grabExcessHorizontalSpace = false;
			classnameTLData.grabExcessVerticalSpace = false;
			classnameT.setLayoutData(classnameTLData);
			classnameT.setFont(clefont);
			classnameT.setSize(new org.eclipse.swt.graphics.Point(313,16));
			classnameT.setBackground(composite3background);
			classnameT.addVerifyListener( new VerifyListener() {
				public void verifyText(VerifyEvent evt) {
					classnameTVerifyText(evt);
				}
			});
			GridLayout composite1Layout = new GridLayout(2, true);
			composite1.setLayout(composite1Layout);
			composite1Layout.marginWidth = 5;
			composite1Layout.marginHeight = 5;
			composite1Layout.numColumns = 2;
			composite1Layout.makeColumnsEqualWidth = false;
			composite1Layout.horizontalSpacing = 5;
			composite1Layout.verticalSpacing = 5;
			composite1.layout();
	
			GridData composite2LData = new GridData();
			composite2LData.verticalAlignment = GridData.CENTER;
			composite2LData.horizontalAlignment = GridData.BEGINNING;
			composite2LData.widthHint = 465;
			composite2LData.heightHint = 46;
			composite2LData.horizontalIndent = 0;
			composite2LData.horizontalSpan = 1;
			composite2LData.verticalSpan = 1;
			composite2LData.grabExcessHorizontalSpace = false;
			composite2LData.grabExcessVerticalSpace = false;
			composite2.setLayoutData(composite2LData);
			composite2.setSize(new org.eclipse.swt.graphics.Point(465,46));
	
			FormData OKLData = new FormData();
			OKLData.height = 21;
			OKLData.width = 91;
			OKLData.left =  new FormAttachment(568, 1000, 0);
			OKLData.right =  new FormAttachment(764, 1000, 0);
			OKLData.top =  new FormAttachment(259, 1000, 0);
			OKLData.bottom =  new FormAttachment(701, 1000, 0);
			OK.setLayoutData(OKLData);
			OK.setText("Finish");
			OK.setSize(new org.eclipse.swt.graphics.Point(91,21));
			OK.setEnabled(false);
			final Font OKfont = new Font(Display.getDefault(),"Courier New",10,1);
			OK.setFont(OKfont);
			OK.setToolTipText("Enter");
			OK.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					OKMouseDown(evt);
				}
			});
	
			FormData cancelLData = new FormData();
			cancelLData.height = 21;
			cancelLData.width = 91;
			cancelLData.left =  new FormAttachment(779, 1000, 0);
			cancelLData.right =  new FormAttachment(975, 1000, 0);
			cancelLData.top =  new FormAttachment(259, 1000, 0);
			cancelLData.bottom =  new FormAttachment(701, 1000, 0);
			cancel.setLayoutData(cancelLData);
			cancel.setText("Cancel");
			cancel.setSize(new org.eclipse.swt.graphics.Point(91,21));
			cancel.setFont(OKfont);
			cancel.setToolTipText("Cancel");
			cancel.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					cancelMouseDown(evt);
				}
			});
			FormLayout composite2Layout = new FormLayout();
			composite2.setLayout(composite2Layout);
			composite2Layout.marginWidth = 0;
			composite2Layout.marginHeight = 0;
			composite2.layout();
			GridLayout dialogShellLayout = new GridLayout(1, true);
			dialogShell.setLayout(dialogShellLayout);
			dialogShellLayout.marginWidth = 5;
			dialogShellLayout.marginHeight = 5;
			dialogShellLayout.numColumns = 1;
			dialogShellLayout.makeColumnsEqualWidth = true;
			dialogShellLayout.horizontalSpacing = 5;
			dialogShellLayout.verticalSpacing = 5;
			dialogShell.layout();
			dialogShell.addDisposeListener(new DisposeListener() {
				public void widgetDisposed(DisposeEvent e) {
					composite3background.dispose();
					clfont.dispose();
					clefont.dispose();
					msgLbIimage.dispose();
					label1image.dispose();
					label2image.dispose();
					composite1font.dispose();
					OKfont.dispose();
				}
			});
			Rectangle bounds = dialogShell.computeTrim(0, 0, 471,245);
			dialogShell.setSize(bounds.width, bounds.height);
			postInitGUI();
			dialogShell.open();
			Display display = dialogShell.getDisplay();
			while (!dialogShell.isDisposed()) {
				if (!display.readAndDispatch())
					display.sleep();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	/** Add your pre-init code in here 	*/
	public void preInitGUI(){
		status = false;
	}

	/** Add your post-init code in here 	*/
	public void postInitGUI(){
		final org.eclipse.swt.graphics.Image msgLbIimage =
		new org.eclipse.swt.graphics.Image(Display.getDefault(),
		getClass().getClassLoader().getResourceAsStream("vocleditor/dialogs/fig/error_st_obj.gif"));
				 
		msgLbIimage.setBackground(msgLbI.getBackground());
		msgLbI.setImage(msgLbIimage);
		msgLb1.setText(msg1);
		msgLbI.setVisible(true);
		msgLb1.setVisible(true);
		msgLb2.setVisible(false);	
	}

	/**
	* This static method creates a new instance of this class and shows
	* it inside a new Shell.
	*
	* It is a convenience method for showing the GUI, but it can be
	* copied and used as a basis for your own code.	*
	* It is auto-generated code - the body of this method will be
	* re-generated after any changes are made to the GUI.
	* However, if you delete this method it will not be re-created.	*/
	public static void showGUI(){
		try {
			Display display = Display.getDefault();
			Shell shell = new Shell(display);
			CreateNewClassDialog inst = new CreateNewClassDialog(shell, SWT.NULL);
			inst.open();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	/** Auto-generated event handler method */
	protected void cancelMouseDown(MouseEvent evt){
		status = false;
		dialogShell.close();
	}

	/** Auto-generated event handler method */
	protected void OKMouseDown(MouseEvent evt){
		status = true;
		varName = varnameT.getText();
		className = classnameT.getText();
		dialogShell.close();
	}

	/**
	* This is an auto-generated method which you can alter,
	* e.g. to point to a different property file, to modify the key by
	* by prefixing the name of this class, etc.
	*
	* By default, it expects a file called "messages.properties" to exist in the
	* current package, and returns the value of the property defined
	* in that file for the given key
	*/
	public String getExternalizedString(String key){
		try {
			return java.util.ResourceBundle.getBundle("vocleditor.dialogs.CreateNewClassDialogMessages").getString(key);
		} catch (java.util.MissingResourceException e) {
			return '!' + key + '!';
		}
	}
	/**
	 * @return
	 */
	public boolean isStatus() {
		return status;
	}


	/**
	 * @return
	 */
	public String getClassName() {
		return className;
	}

	/**
	 * @return
	 */
	public String getVariableName() {
		return varName;
	}



	/** Auto-generated event handler method */
	protected void classnameTVerifyText(VerifyEvent evt){
		if(classnameT.getText().length()==1 & evt.text.equals("")){
			final org.eclipse.swt.graphics.Image msgLbIimage =
				 new org.eclipse.swt.graphics.Image(Display.getDefault(),
				 getClass().getClassLoader().getResourceAsStream("vocleditor/dialogs/fig/error_st_obj.gif"));
				 
			msgLbIimage.setBackground(msgLbI.getBackground());
			msgLbI.setImage(msgLbIimage);
			msgLb1.setText(msg1);
			msgLbI.setVisible(true);
			msgLb1.setVisible(true);
			msgLb2.setVisible(false);
			OK.setEnabled(false);
		}
		if(classnameT.getText().length()==0 & !evt.text.trim().equals("") ){
			if(Character.isUpperCase(evt.character)){
				msgLbI.setVisible(false);
				msgLb1.setVisible(false);
				msgLb2.setVisible(false);
			}else{
				final org.eclipse.swt.graphics.Image msgLbIimage =
					new org.eclipse.swt.graphics.Image(Display.getDefault(),
					getClass().getClassLoader().getResourceAsStream("vocleditor/dialogs/fig/warning_st_obj.gif"));
					
				msgLbIimage.setBackground(msgLbI.getBackground());
				msgLbI.setImage(msgLbIimage);
				msgLb1.setText(msg2a);
				msgLbI.setVisible(true);
				msgLb1.setVisible(true);
				msgLb2.setVisible(true);				
			}
			OK.setEnabled(true);
		}
		if(classnameT.getText().length()>0 & Character.isUpperCase(evt.character) & evt.start==0){
			msgLbI.setVisible(false);
			msgLb1.setVisible(false);
			msgLb2.setVisible(false);
		}
	}
}
