/**
 * (c) Copyright group Vilapower
 *
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0 
 * which accompanies this distribution, and is available at
 * http://www.tfs.cs.tu-berlin.de/vila
 * 
 * Contributors:
 *     	Eduard Weiss
 * 		Tony Modica
 * 		Frank Hermann
 * 		Holger Endert
 * 
 */

package vocleditor.dialogs;

import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.SWT;

/**
* This code was generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a
* for-profit company or business) then you should purchase
* a license - please visit www.cloudgarden.com for details.
*/
public class ExpressionDialog extends org.eclipse.swt.widgets.Dialog {
	private Text typeT;
	private Text nameT;
	private Label typeLb;
	private Label varnameLb;
	private Label label3;
	private Label label2;
	private Button verticalB;
	private Button cancel;
	private Button enter;
	private Label kindLb;
	private Combo kindC;
	private Composite composite2;
	private Group group1;
	private Label nameLb;
	private Label label1;
	private Composite composite1;
	private Shell dialogShell;
	
	private boolean state=false;
	private int kind=0;
	private boolean vertical=true;
	private String name="";
	private String varname="";
	private String vartype="";

	public ExpressionDialog(Shell parent, int style) {
		super(parent, style);
	}

	/**
	* Opens the Dialog Shell.
	* Auto-generated code - any changes you make will disappear.
	*/
	public void open(){
		try {
			preInitGUI();
	
			Shell parent = getParent();
			dialogShell = new Shell(parent, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);
			dialogShell.setText(getText());
			composite1 = new Composite(dialogShell,SWT.NULL);
			label3 = new Label(composite1,SWT.NULL);
			label2 = new Label(composite1,SWT.NULL);
			nameLb = new Label(composite1,SWT.NULL);
			label1 = new Label(composite1,SWT.NULL);
			group1 = new Group(dialogShell,SWT.NO_RADIO_GROUP);
			typeT = new Text(group1,SWT.BORDER);
			nameT = new Text(group1,SWT.BORDER);
			typeLb = new Label(group1,SWT.NULL);
			varnameLb = new Label(group1,SWT.NULL);
			verticalB = new Button(group1,SWT.CHECK| SWT.LEFT);
			kindLb = new Label(group1,SWT.NULL);
			kindC = new Combo(group1,SWT.READ_ONLY| SWT.BORDER);
			composite2 = new Composite(dialogShell,SWT.NULL);
			cancel = new Button(composite2,SWT.PUSH| SWT.CENTER);
			enter = new Button(composite2,SWT.PUSH| SWT.CENTER);
	
			dialogShell.setText("Bool Expression");
			dialogShell.setSize(new org.eclipse.swt.graphics.Point(310,216));
	
			GridData composite1LData = new GridData();
			composite1LData.verticalAlignment = GridData.CENTER;
			composite1LData.horizontalAlignment = GridData.BEGINNING;
			composite1LData.widthHint = 300;
			composite1LData.heightHint = 50;
			composite1LData.horizontalIndent = 0;
			composite1LData.horizontalSpan = 1;
			composite1LData.verticalSpan = 1;
			composite1LData.grabExcessHorizontalSpace = false;
			composite1LData.grabExcessVerticalSpace = false;
			composite1.setLayoutData(composite1LData);
			composite1.setSize(new org.eclipse.swt.graphics.Point(300,50));
			final Color composite1background = new Color(Display.getDefault(),255,255,255);
			composite1.setBackground(composite1background);
			final Font composite1font = new Font(Display.getDefault(),"Courier New",12,1);
			composite1.setFont(composite1font);
	
			FormData label3LData = new FormData();
			label3LData.height = 43;
			label3LData.width = 55;
			label3LData.left =  new FormAttachment(15, 1000, 0);
			label3LData.right =  new FormAttachment(198, 1000, 0);
			label3LData.top =  new FormAttachment(90, 1000, 0);
			label3LData.bottom =  new FormAttachment(950, 1000, 0);
			label3.setLayoutData(label3LData);
			label3.setText("label3");
			final org.eclipse.swt.graphics.Image label3image = new org.eclipse.swt.graphics.Image(Display.getDefault(), getClass().getClassLoader().getResourceAsStream("vocleditor/dialogs/fig/newEEnum_wizR.GIF"));
			label3image.setBackground(label3.getBackground());
			label3.setImage(label3image);
			label3.setSize(new org.eclipse.swt.graphics.Point(55,43));
	
			FormData label2LData = new FormData();
			label2LData.height = 42;
			label2LData.width = 62;
			label2LData.left =  new FormAttachment(781, 1000, 0);
			label2LData.right =  new FormAttachment(988, 1000, 0);
			label2LData.top =  new FormAttachment(110, 1000, 0);
			label2LData.bottom =  new FormAttachment(950, 1000, 0);
			label2.setLayoutData(label2LData);
			label2.setText("label2");
			final org.eclipse.swt.graphics.Image label2image = new org.eclipse.swt.graphics.Image(Display.getDefault(), getClass().getClassLoader().getResourceAsStream("vocleditor/dialogs/fig/newprj_wiz.gif"));
			label2image.setBackground(label2.getBackground());
			label2.setImage(label2image);
			label2.setSize(new org.eclipse.swt.graphics.Point(62,42));
	
			FormData nameLbLData = new FormData();
			nameLbLData.height = 19;
			nameLbLData.width = 60;
			nameLbLData.left =  new FormAttachment(578, 1000, 0);
			nameLbLData.right =  new FormAttachment(778, 1000, 0);
			nameLbLData.top =  new FormAttachment(190, 1000, 0);
			nameLbLData.bottom =  new FormAttachment(570, 1000, 0);
			nameLb.setLayoutData(nameLbLData);
			nameLb.setText("Bool");
			nameLb.setSize(new org.eclipse.swt.graphics.Point(60,19));
			nameLb.setBackground(composite1background);
			nameLb.setFont(composite1font);
	
			FormData label1LData = new FormData();
			label1LData.height = 19;
			label1LData.width = 105;
			label1LData.left =  new FormAttachment(211, 1000, 0);
			label1LData.right =  new FormAttachment(561, 1000, 0);
			label1LData.top =  new FormAttachment(190, 1000, 0);
			label1LData.bottom =  new FormAttachment(570, 1000, 0);
			label1.setLayoutData(label1LData);
			label1.setAlignment(SWT.LEFT);
			label1.setText("Expression");
			label1.setSize(new org.eclipse.swt.graphics.Point(105,19));
			label1.setBackground(composite1background);
			label1.setFont(composite1font);
			FormLayout composite1Layout = new FormLayout();
			composite1.setLayout(composite1Layout);
			composite1Layout.marginWidth = 0;
			composite1Layout.marginHeight = 0;
			composite1.layout();
	
			GridData group1LData = new GridData();
			group1LData.verticalAlignment = GridData.CENTER;
			group1LData.horizontalAlignment = GridData.BEGINNING;
			group1LData.widthHint = 294;
			group1LData.heightHint = 84;
			group1LData.horizontalIndent = 0;
			group1LData.horizontalSpan = 1;
			group1LData.verticalSpan = 1;
			group1LData.grabExcessHorizontalSpace = false;
			group1LData.grabExcessVerticalSpace = false;
			group1.setLayoutData(group1LData);
			group1.setSize(new org.eclipse.swt.graphics.Point(294,84));
	
			FormData typeTLData = new FormData();
			typeTLData.height = 13;
			typeTLData.width = 93;
			typeTLData.left =  new FormAttachment(525, 1000, 0);
			typeTLData.right =  new FormAttachment(865, 1000, 0);
			typeTLData.top =  new FormAttachment(363, 1000, 0);
			typeTLData.bottom =  new FormAttachment(601, 1000, 0);
			typeT.setLayoutData(typeTLData);
			final Font typeTfont = new Font(Display.getDefault(),"Courier New",10,0);
			typeT.setFont(typeTfont);
			typeT.setSize(new org.eclipse.swt.graphics.Point(93,13));
	
			FormData nameTLData = new FormData();
			nameTLData.height = 17;
			nameTLData.width = 91;
			nameTLData.left =  new FormAttachment(525, 1000, 0);
			nameTLData.right =  new FormAttachment(865, 1000, 0);
			nameTLData.top =  new FormAttachment(29, 1000, 0);
			nameTLData.bottom =  new FormAttachment(315, 1000, 0);
			nameT.setLayoutData(nameTLData);
			final Font nameTfont = new Font(Display.getDefault(),"Courier New",10,1);
			nameT.setFont(nameTfont);
			nameT.setSize(new org.eclipse.swt.graphics.Point(91,17));
	
			FormData typeLbLData = new FormData();
			typeLbLData.height = 20;
			typeLbLData.width = 140;
			typeLbLData.left =  new FormAttachment(8, 1000, 0);
			typeLbLData.right =  new FormAttachment(484, 1000, 0);
			typeLbLData.top =  new FormAttachment(386, 1000, 0);
			typeLbLData.bottom =  new FormAttachment(625, 1000, 0);
			typeLb.setLayoutData(typeLbLData);
			typeLb.setAlignment(SWT.RIGHT);
			typeLb.setText("type:");
			typeLb.setSize(new org.eclipse.swt.graphics.Point(140,20));
			typeLb.setFont(nameTfont);
	
			FormData varnameLbLData = new FormData();
			varnameLbLData.height = 20;
			varnameLbLData.width = 140;
			varnameLbLData.left =  new FormAttachment(8, 1000, 0);
			varnameLbLData.right =  new FormAttachment(484, 1000, 0);
			varnameLbLData.top =  new FormAttachment(89, 1000, 0);
			varnameLbLData.bottom =  new FormAttachment(327, 1000, 0);
			varnameLb.setLayoutData(varnameLbLData);
			varnameLb.setText("name of variable:");
			varnameLb.setSize(new org.eclipse.swt.graphics.Point(140,20));
			varnameLb.setFont(nameTfont);
	
			FormData verticalBLData = new FormData();
			verticalBLData.height = 20;
			verticalBLData.width = 110;
			verticalBLData.left =  new FormAttachment(8, 1000, 0);
			verticalBLData.right =  new FormAttachment(382, 1000, 0);
			verticalBLData.top =  new FormAttachment(732, 1000, 0);
			verticalBLData.bottom =  new FormAttachment(970, 1000, 0);
			verticalB.setLayoutData(verticalBLData);
			verticalB.setSelection(true);
			verticalB.setText("is vertical");
			verticalB.setSize(new org.eclipse.swt.graphics.Point(110,20));
			verticalB.setFont(nameTfont);
			verticalB.addSelectionListener( new SelectionAdapter() {
				public void widgetSelected(SelectionEvent evt) {
					verticalBWidgetSelected(evt);
				}
			});
	
			FormData kindLbLData = new FormData();
			kindLbLData.height = 20;
			kindLbLData.width = 150;
			kindLbLData.left =  new FormAttachment(8, 1000, 0);
			kindLbLData.right =  new FormAttachment(518, 1000, 0);
			kindLbLData.top =  new FormAttachment(89, 1000, 0);
			kindLbLData.bottom =  new FormAttachment(327, 1000, 0);
			kindLb.setLayoutData(kindLbLData);
			kindLb.setText("Kind of expression:");
			kindLb.setSize(new org.eclipse.swt.graphics.Point(150,20));
			kindLb.setFont(nameTfont);
	
			FormData kindCLData = new FormData();
			kindCLData.height = 27;
			kindCLData.width = 75;
			kindCLData.left =  new FormAttachment(525, 1000, 0);
			kindCLData.right =  new FormAttachment(865, 1000, 0);
			kindCLData.top =  new FormAttachment(29, 1000, 0);
			kindCLData.bottom =  new FormAttachment(315, 1000, 0);
			kindC.setLayoutData(kindCLData);
			kindC.setSize(new org.eclipse.swt.graphics.Point(75,27));
			kindC.setFont(typeTfont);
			FormLayout group1Layout = new FormLayout();
			group1.setLayout(group1Layout);
			group1Layout.marginWidth = 0;
			group1Layout.marginHeight = 0;
			group1.layout();
	
			GridData composite2LData = new GridData();
			composite2LData.verticalAlignment = GridData.CENTER;
			composite2LData.horizontalAlignment = GridData.BEGINNING;
			composite2LData.widthHint = 300;
			composite2LData.heightHint = 45;
			composite2LData.horizontalIndent = 0;
			composite2LData.horizontalSpan = 1;
			composite2LData.verticalSpan = 1;
			composite2LData.grabExcessHorizontalSpace = false;
			composite2LData.grabExcessVerticalSpace = false;
			composite2.setLayoutData(composite2LData);
			composite2.setSize(new org.eclipse.swt.graphics.Point(300,45));
	
			FormData cancelLData = new FormData();
			cancelLData.height = 25;
			cancelLData.width = 85;
			cancelLData.left =  new FormAttachment(718, 1000, 0);
			cancelLData.right =  new FormAttachment(1001, 1000, 0);
			cancelLData.top =  new FormAttachment(344, 1000, 0);
			cancelLData.bottom =  new FormAttachment(900, 1000, 0);
			cancel.setLayoutData(cancelLData);
			cancel.setText("CANCEL");
			cancel.setSize(new org.eclipse.swt.graphics.Point(85,25));
			cancel.setFont(nameTfont);
			cancel.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					cancelMouseDown(evt);
				}
			});
	
			FormData enterLData = new FormData();
			enterLData.height = 25;
			enterLData.width = 85;
			enterLData.left =  new FormAttachment(401, 1000, 0);
			enterLData.right =  new FormAttachment(685, 1000, 0);
			enterLData.top =  new FormAttachment(344, 1000, 0);
			enterLData.bottom =  new FormAttachment(900, 1000, 0);
			enter.setLayoutData(enterLData);
			enter.setText("ENTER");
			enter.setSize(new org.eclipse.swt.graphics.Point(85,25));
			enter.setFont(nameTfont);
			enter.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					enterMouseDown(evt);
				}
			});
			FormLayout composite2Layout = new FormLayout();
			composite2.setLayout(composite2Layout);
			composite2Layout.marginWidth = 0;
			composite2Layout.marginHeight = 0;
			composite2.layout();
			GridLayout dialogShellLayout = new GridLayout(1, true);
			dialogShell.setLayout(dialogShellLayout);
			dialogShellLayout.marginWidth = 5;
			dialogShellLayout.marginHeight = 5;
			dialogShellLayout.numColumns = 1;
			dialogShellLayout.makeColumnsEqualWidth = true;
			dialogShellLayout.horizontalSpacing = 5;
			dialogShellLayout.verticalSpacing = 5;
			dialogShell.layout();
			dialogShell.addDisposeListener(new DisposeListener() {
				public void widgetDisposed(DisposeEvent e) {
					composite1background.dispose();
					composite1font.dispose();
					label3image.dispose();
					label2image.dispose();
					typeTfont.dispose();
					nameTfont.dispose();
				}
			});
			Rectangle bounds = dialogShell.computeTrim(0, 0, 310,216);
			dialogShell.setSize(bounds.width, bounds.height);
			postInitGUI();
			dialogShell.open();
			Display display = dialogShell.getDisplay();
			while (!dialogShell.isDisposed()) {
				if (!display.readAndDispatch())
					display.sleep();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	/** Add your pre-init code in here 	*/
	public void preInitGUI(){
	}

	/** Add your post-init code in here 	*/
	public void postInitGUI(){
		
		dialogShell.setText(getName());
		nameLb.setText(getName());
		if(getName().equals("Bool")){
			kindC.setVisible(true);
			kindLb.setVisible(true);
			varnameLb.setVisible(false);
			nameT.setVisible(false);
			typeLb.setVisible(false);
			typeT.setVisible(false);
		}else{
			kindC.setVisible(false);
			kindLb.setVisible(false);
			varnameLb.setVisible(true);
			nameT.setVisible(true);
			typeLb.setVisible(true);
			typeT.setVisible(true);
		}
		kindC.add("OR");
		kindC.add("AND");
		kindC.add("XOR");
		kindC.add("IMPLIES");
		kindC.select(0);	
	}

	/** Auto-generated main method */
	public static void main(String[] args){
		showGUI();
	}

	/**
	* This static method creates a new instance of this class and shows
	* it inside a new Shell.
	*
	* It is a convenience method for showing the GUI, but it can be
	* copied and used as a basis for your own code.	*
	* It is auto-generated code - the body of this method will be
	* re-generated after any changes are made to the GUI.
	* However, if you delete this method it will not be re-created.	*/
	public static void showGUI(){
		try {
			Display display = Display.getDefault();
			Shell shell = new Shell(display);
			ExpressionDialog inst = new ExpressionDialog(shell, SWT.NULL);
			inst.open();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	/** Auto-generated event handler method */
	protected void verticalBWidgetSelected(SelectionEvent evt){
		if(verticalB.getSelection())setVertical(true);
		else setVertical(false);
	
	}

	/** Auto-generated event handler method */
	protected void cancelMouseDown(MouseEvent evt){
		dialogShell.close();
	}

	/** Auto-generated event handler method */
	protected void enterMouseDown(MouseEvent evt){
		setKind(kindC.getSelectionIndex());
		if(getName().equals("Let")){
			if(nameT.getText().trim().length()==0 ||
				typeT.getText().trim().length()==0){
					MessageBox msgb = new MessageBox(dialogShell,0);
					msgb.setText("ERROR #100234");
					msgb.setMessage("Variable name or type is empty!");
					msgb.open();
					return;
				}
		}
		setState(true);
		setVarname(nameT.getText());
		setVartype(typeT.getText());
		dialogShell.close();
	}
	/**
	 * @return
	 */
	public boolean isState() {
		return state;
	}

	/**
	 * @param b
	 */
	public void setState(boolean b) {
		state = b;
	}

	/**
	 * @return
	 */
	public int getKind() {
		return kind;
	}

	/**
	 * @return
	 */
	public boolean isVertical() {
		return vertical;
	}

	/**
	 * @param string
	 */
	public void setKind(int i) {
		kind = i;
	}

	/**
	 * @param button
	 */
	public void setVertical(boolean b) {
		vertical = b;
	}

	/**
	 * @return
	 */
	public String getName() {
		return name;
	}

	/**
	 * @param string
	 */
	public void setName(String string) {
		name = string;
	}

	/**
	 * @return
	 */
	public String getVarname() {
		return varname;
	}

	/**
	 * @return
	 */
	public String getVartype() {
		return vartype;
	}

	/**
	 * @param string
	 */
	public void setVarname(String string) {
		varname = string;
	}

	/**
	 * @param string
	 */
	public void setVartype(String string) {
		vartype = string;
	}

}
