/**
 * (c) Copyright group Vilapower
 *
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0 
 * which accompanies this distribution, and is available at
 * http://www.tfs.cs.tu-berlin.de/vila
 * 
 * Contributors:
 *     	Eduard Weiss
 * 		Tony Modica
 * 		Frank Hermann
 * 		Holger Endert
 * 
 */
package vocleditor.editors.tools;

import org.eclipse.swt.widgets.Shell;

import vocleditor.commands.adds.AddConditionCommand;
import vocleditor.commands.adds.SetClassifierPropsCommand;
import vocleditor.commands.adds.ClassifierPropsCommand;
import vocleditor.dialogs.ClassifierPropertyDialog;
import vocleditor.dialogs.SetClassifierPropertyDialog;
import vocleditor.dialogs.SetConditiontPropertyDialog;

/**
 * @author eddi
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class VOCLProperties {
	
	public VOCLProperties(){}
	
	

	public boolean openDialogForClassifierRoleProperty(ClassifierPropsCommand command,Shell shell){
		ClassifierPropertyDialog cpd = new ClassifierPropertyDialog(shell,0);
		cpd.setValues(command.getValues());
		cpd.open();	
		command.setValues(cpd.getValues());
		return true;
	}


	
	public boolean openDialogAddCondition(AddConditionCommand command ,Shell shell){
		SetConditiontPropertyDialog cpd = new SetConditiontPropertyDialog(shell,0);
		cpd.setCondition(command.getConditionsList());
		if(command.getConstraint().getName()!=null)
			cpd.setNameOfConstraint(command.getConstraint().getName());
		else cpd.setNameOfConstraint("");
		cpd.open();	
		if(!cpd.isState()) return false;
		command.setConditionsList(cpd.getConditions());
		return true;
	}
	
	/**
	 * This method opens the dialog for editing the CollectionClassifierProperties.
	 * @param command - The Command executing all edited things
	 * @param shell - the shell where to open the dialog
	 * @return - true, if dialog was not canceled and some changes where made
	 */
	public boolean openSetClassifierPropertyDialog(SetClassifierPropsCommand command, Shell shell) {
		SetClassifierPropertyDialog scpd = new SetClassifierPropertyDialog(shell, 0, command.getInitialValues());
		// insert the complete initialized Hashtable
		// scpd.setChanges(command.getInitialValues());
		
		scpd.open();
		if (!scpd.hasChanged()) return false;
		else {
			command.setChanges(scpd.getChanges());
		}
		return true;
	}
	
	
}
