/**
 * (c) Copyright group Vilapower
 *
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0 
 * which accompanies this distribution, and is available at
 * http://www.tfs.cs.tu-berlin.de/vila
 * 
 * Contributors:
 *     	Eduard Weiss
 * 		Tony Modica
 * 		Frank Hermann
 * 		Holger Endert
 * 
 */
package vocleditor.figure;

import org.eclipse.draw2d.AbstractConnectionAnchor;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.draw2d.geometry.PrecisionPoint;
import org.eclipse.draw2d.geometry.Rectangle;

/**
 * @author vilapower
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class VoclAnchor extends AbstractConnectionAnchor {

	private int xOffset;
	private int yOffset;
	private int id;
	
	
	/**
	 * Constructor for a anchor point at an Classifier Role Figure
	 * @param owner
	 */
	public VoclAnchor(IFigure owner) {
		super(owner);
	}


	/**
	 * Sets the offset of an anchor point according to the top
	 * left corner of a classifier role figure.
	 * @param offset
	 */
	public void setOffset(int x, int y) {
		xOffset = x;
		yOffset = y;
	}





	/**
	 * @see org.eclipse.draw2d.ConnectionAnchor#getLocation(org.eclipse.draw2d.geometry.Point)
	 */
	public Point getLocation(Point reference) {
		Rectangle r = getOwner().getBounds();
		
		int x,y;
		x = r.x + xOffset;
		y = r.y + yOffset;
	
		Point p = new PrecisionPoint(x,y);
		getOwner().translateToAbsolute(p);
		return p;
	}

	public int getxOffset(){
		return xOffset;
	}
	
	public int getyOffset(){
		return yOffset;
	}

	/**
	 * @see org.eclipse.draw2d.ConnectionAnchor#getReferencePoint()
	 */
	public Point getReferencePoint(){
		return getLocation(null);
	}

	/**
	 * @return
	 */
	public int getId() {
		return id;
	}

	/**
	 * @param i
	 */
	public void setId(int i) {
		id = i;
	}

}
